import { __decorate } from "tslib";
import { isLayout, mapStateToLayoutProps, rankWith } from '@jsonforms/core';
import { attr, customElement, FASTElement, html, observable, repeat, when, } from '@microsoft/fast-element';
import { LAYOUT_RANK } from './RenderersRanks';
let LayoutWrapper = class LayoutWrapper extends FASTElement {
    constructor() {
        super(...arguments);
        this.hideLabel = false;
    }
};
__decorate([
    observable
], LayoutWrapper.prototype, "control", void 0);
__decorate([
    attr({ mode: 'boolean', attribute: 'hide-label' })
], LayoutWrapper.prototype, "hideLabel", void 0);
LayoutWrapper = __decorate([
    customElement({
        name: 'layout-wrapper',
        template: html `
    ${when((x) => x.control.label && !x.hideLabel, html `
        <div style="color: var(--neutral-foreground-hint);">${(x) => x.control.label}</div>
      `)}
    ${when((x) => { var _a; return (_a = x.control) === null || _a === void 0 ? void 0 : _a.visible; }, html `
        <slot></slot>
      `)}
  `,
    })
], LayoutWrapper);
export { LayoutWrapper };
export const LayoutRendererTemplate = html `
  <template>
    <layout-wrapper :control=${(x) => x.control}>
      <div>
        ${repeat((x) => x.control.uischema.elements, html `
            <dispatch-renderer
              ?submitted=${(x, ctx) => ctx.parent.submitted}
              :dispatch=${(x, ctx) => ctx.parent.dispatch}
              :jsonforms=${(x, ctx) => ctx.parent.jsonforms}
              :prefix=${(x, ctx) => ctx.parent.prefix}
              :props=${(x, ctx) => ({
    uischema: x,
    schema: ctx.parent.control.schema,
    renderers: ctx.parent.control.renderers,
    path: ctx.parent.control.path,
    enabled: ctx.parent.control.enabled,
})}
            ></dispatch-renderer>
          `)}
      </div>
    </layout-wrapper>
  </template>
`;
export const LayoutRendererEntry = {
    renderer: LayoutRendererTemplate,
    tester: rankWith(LAYOUT_RANK, isLayout),
    mapper: mapStateToLayoutProps,
};
